package cpcns.danganzhengli.xinbiaozhun.controller;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cpcns.baoguanqixiancelue.service.IGBaoGuanQiXianWeiHuService;
import cpcns.base.common.User;
import cpcns.base.common.util.JsonWithJacksonUtils;
import cpcns.base.configuration.AppConfiguration;
import cpcns.base.generic.ResultMessage;
import cpcns.common.controller.commonController;
import cpcns.common.service.ICommonService;
import cpcns.danganmenlei.model.GDangAnMenLei;
import cpcns.danganmenlei.service.IGDangAnMenLeiService;
import cpcns.danganzhengli.xinbiaozhun.model.DXinBiaoZhun;
import cpcns.danganzhengli.xinbiaozhun.service.IDXinBiaoZhunService;
import cpcns.jhsks.xinxifenlei.xitongmokuai.xitongpeizhidaima.service.IXiTongDaiMaService;
import cpcns.jhsks.yonghuguanli.model.JiGouFenLei;
import cpcns.utils.CommStatic;
import cpcns.utils.PagerVO;
import java.io.IOException;
import java.text.ParseException;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import net.sf.json.JSONObject;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping({"/dXinBiaoZhun"})
public class DXinBiaoZhunController extends commonController {
  @Autowired
  private IDXinBiaoZhunService dXinBiaoZhunService;
  
  @Autowired
  private ICommonService commonService;
  
  @Autowired
  private IGDangAnMenLeiService gDangAnMenLeiService;
  
  @Autowired
  private IGBaoGuanQiXianWeiHuService gBaoGuanQiXianWeiHuService;
  
  @Autowired
  private IXiTongDaiMaService xiTongDaiMaService;
  
  @RequestMapping({"/query.do"})
  public String execute(HttpServletRequest request) throws Exception {
    return "danganzhengli/D_XinBiaoZhun/D_XinBiaoZhun_list";
  }
  
  @RequestMapping({"/getAll.do"})
  public String getAll(HttpServletRequest request, HttpServletResponse response, Model model) throws IOException {
    try {
      Enumeration<?> rnames = getRequest().getParameterNames();
      JSONObject jsonObject = new JSONObject();
      for (Enumeration<?> er = rnames; er.hasMoreElements(); ) {
        String thisName = er.nextElement().toString();
        String thisValue = getRequest().getParameter(thisName);
        jsonObject.put(thisName, thisValue);
      } 
      User user = getCurrentUser();
      StringBuffer sqlWhere = new StringBuffer("1=1 ");
      Iterator<String> iterator = jsonObject.keys();
      Map<String, String> tjmap = new HashMap<>();
      sqlWhere.append(CommStatic.IsQuanXian(user, AppConfiguration.getConfigValue("CPCNS_XITONGLEIXING"), tjmap));
      while (iterator.hasNext()) {
        String key = iterator.next();
        String value = jsonObject.getString(key);
        if (value != null && !value.trim().equals("") && !key.equals("page") && !key.equals("rows") && !"order".equals(key) && !"sort".equals(key)) {
          if (key.endsWith("begin")) {
            key = key.substring(0, key.indexOf("begin"));
            sqlWhere.append(" and ").append(String.valueOf(key) + " >= " + "to_date('" + value + "','yyyy-mm-dd')");
            continue;
          } 
          if (key.endsWith("end")) {
            key = key.substring(0, key.indexOf("end"));
            sqlWhere.append(" and ").append(
                String.valueOf(key) + " <= " + "to_date('" + value + "','yyyy-mm-dd')");
            continue;
          } 
          if (!"server".equals(key) && !"table".equals(key)) {
            if (key.endsWith("like")) {
              key = key.substring(0, key.indexOf("like"));
              sqlWhere.append(" and ").append(String.valueOf(key) + " like " + "'%" + value.trim() + "%'");
              continue;
            } 
            if (key.equals("guanLianBiaoShi") && value.equals("2")) {
              sqlWhere.append(" and guanLianBiaoShi > 0");
              continue;
            } 
            if (key.equals("guanLianBiaoShi") && value.equals("0")) {
              sqlWhere.append(" and guanLianBiaoShi =").append(value);
              continue;
            } 
            sqlWhere.append(" and ").append(String.valueOf(key) + " = '" + value + "'");
          } 
        } 
      } 
      sqlWhere.append(" and zhuangTai not in (3,4)");
      String page = request.getParameter("page");
      String rows = request.getParameter("rows");
      model.addAttribute("page", page);
      model.addAttribute("rows", rows);
      int intPage = Integer.parseInt((page == null || page == "0") ? "0" : page);
      int number = Integer.parseInt((rows == null || rows == "0") ? "0" : rows);
      StringBuffer sql = new StringBuffer("select * from  D_WenJian_XinBiaoZhun  where ");
      int start = (intPage - 1) * number;
      PagerVO pagevo = this.dXinBiaoZhunService.getAll(start, number, sql.toString(), sqlWhere.toString(), CommStatic.getOrderBy(request, "hangbiaoshi"));
      String jsonString = JsonWithJacksonUtils.getInstance().obj2Json(pagevo);
      jsonString = jsonString.replaceAll("HANGBIAOSHI", "hangBiaoShi").replaceAll("XUHAO", "xuHao")
        .replaceAll("GUANLIANBIAOSHI", "guanLianBiaoShi").replaceAll("YESHU", "yeShu")
        .replaceAll("BIAOTI", "biaoTi").replaceAll("DANGHAO", "dangHao").replaceAll("WENHAO", "wenHao")
        .replaceAll("MIJI", "miJi").replaceAll("CHENGWENRIQI", "chengWenRiQi").replaceAll("LIYUANDANWEIMINGCHENG", "liJuanDanWeiMingCheng")
        .replaceAll("LIJUANDANWEIBIAOSHI", "liJuanDanWeiBiaoShi").replaceAll("GUIDANGBUMENMINGCHENG", "guiDangBuMenMingCheng")
        .replaceAll("GUIDANGBUMENBIAOSHI", "guiDangBuMenBiaoShi").replaceAll("BAOGUANQIXIAN", "baoGuanQiXian").replaceAll("FENSHU", "fenShu")
        .replaceAll("GUIDANGNIANDU", "guiDangNianDu").replaceAll("GUIDANGLEIXING", "guiDangLeiXing").replaceAll("YOUYUANWEN", "youYuanWen")
        .replaceAll("WENZHONG", "wenZhong").replaceAll("FENLEIMINGCHENG", "fenLeiMingCheng").replaceAll("ZHUANGTAI", "zhuangTai");
      write(response, jsonString);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return null;
  }
  
  @RequestMapping({"/toAdd.do"})
  public String toAdd(HttpServletRequest request, Model model) throws Exception {
    User user = getCurrentUser();
    String menLei = request.getParameter("menLei");
    DXinBiaoZhun xbz = new DXinBiaoZhun();
    String type = request.getParameter("type");
    xbz.setYouYuanWen(Integer.valueOf(0));
    xbz.setGuanLianBiaoShi(Integer.valueOf(0));
    xbz.setKaiFangZhuangTai(Integer.valueOf(0));
    xbz.setFenShu(Integer.valueOf(1));
    xbz.setShuJuLaiYuan(Integer.valueOf(3));
    xbz.setSiXingJianChaBiaoShi("0|0|0|0");
    xbz.setJieYueZhuangTai(Integer.valueOf(0));
    xbz.setKaiFangZhuangTai(Integer.valueOf(0));
    xbz.setGuanLianBiaoShi(Integer.valueOf(0));
    xbz.setZhuangTai(Integer.valueOf(0));
    if (user != null) {
      JiGouFenLei jg = this.commonService.getJiGouRenYuan(Integer.parseInt(user.findCurrentBuMenBiaoShi()));
      if (jg != null) {
        xbz.setGuiDangBuMenBiaoShi(jg.getBiaoShi());
        xbz.setGuiDangBuMenMingCheng(jg.getMingCheng());
      } 
      xbz.setLiJuanDanWeiMingCheng(user.findRootBuMenMingCheng());
      xbz.setLiJuanDanWeiBiaoShi(Integer.valueOf(user.findRootBuMenBiaoShi()));
      xbz.setLuRuRenBiaoShi(Integer.valueOf(user.getBiaoShi().intValue()));
      xbz.setLuRuRenMingCheng(user.getMingCheng());
      xbz.setQuanZongHao(user.getQuanZongHao());
    } 
    xbz.setGuanLianBiaoShi(Integer.valueOf(0));
    xbz.setYeShu(Integer.valueOf(1));
    model.addAttribute("OFDType", AppConfiguration.getConfigValue("OFDType"));
    model.addAttribute("DXinBiaoZhun", xbz);
    model.addAttribute("type", type);
    model.addAttribute("buMenJieDianBiaoShi", user.findRootBuMenJieDianBiaoShi());
    model.addAttribute("menLei", menLei);
    return "danganzhengli/D_XinBiaoZhun/D_XinBiaoZhun_edit";
  }
  
  @RequestMapping({"/save.do"})
  @ResponseBody
  public void save(HttpServletRequest request, HttpServletResponse response) throws Exception {
    ResultMessage rm = new ResultMessage();
    String server = request.getParameter("server");
    String info = "";
    Enumeration<?> rnames = getRequest().getParameterNames();
    JSONObject jsonObject = new JSONObject();
    for (Enumeration<?> er = rnames; er.hasMoreElements(); ) {
      String thisName = er.nextElement().toString();
      String thisValue = getRequest().getParameter(thisName);
      jsonObject.put(thisName, thisValue);
    } 
    DXinBiaoZhun t = (DXinBiaoZhun)JsonWithJacksonUtils.getInstance().json2Obj(jsonObject.toString(), DXinBiaoZhun.class);
    Map<String, String> map1 = new HashMap<>();
    map1.put("table", this.table);
    map1.put("server", server);
    map1.put("guiDangNianDu", t.getGuiDangNianDu());
    map1.put("biaoTiString", t.getBiaoTi());
    map1.put("zhuangTai_not", "3");
    if (t.getHangBiaoShi() != null && t.getHangBiaoShi().intValue() > 0)
      map1.put("hangBiaoShi_not", String.valueOf(t.getHangBiaoShi())); 
    if (t != null) {
      if (!this.dXinBiaoZhunService.IsExist(map1)) {
        if (t.getHangBiaoShi() == null || t.getHangBiaoShi().equals("")) {
          t.setHangBiaoShi(Integer.valueOf(this.dXinBiaoZhunService.getPk()));
          t.setYouYuanWen(Integer.valueOf(0));
          t.setFenShu(Integer.valueOf(1));
          t.setShuJuLaiYuan(Integer.valueOf(3));
          t.setSiXingJianChaBiaoShi("0|0|0|0");
          t.setJieYueZhuangTai(Integer.valueOf(0));
          t.setKaiFangZhuangTai(Integer.valueOf(0));
          t.setGuanLianBiaoShi(Integer.valueOf(0));
          t.setZhuangTai(Integer.valueOf(0));
        } 
        try {
          User user = getCurrentUser();
          this.dXinBiaoZhunService.saveOrUpdate(t);
          rm.setSuccess(true);
          rm.addResultMessage("hangBiaoShi", t.getHangBiaoShi());
          info = "保存成功！";
        } catch (Exception e) {
          e.printStackTrace();
          info = "保存失败！";
          rm.setSuccess(false);
        } 
      } else {
        rm.setSuccess(false);
        info = "标题已存在";
      } 
      rm.setInfo(info);
      responseWriter(response, rm.toString());
    } else {
      info = "数据转换错误！";
    } 
  }
  
  @RequestMapping({"/open.do"})
  public String open(HttpServletRequest request, HttpServletResponse response, Model model) throws ParseException {
    String hangBiaoShi = request.getParameter("hangBiaoShi");
    String ids = request.getParameter("keyWordResult");
    String type = request.getParameter("type");
    String textKey = request.getParameter("textKey");
    if (hangBiaoShi != null && !hangBiaoShi.equals("")) {
      String state = request.getParameter("state");
      DXinBiaoZhun cla = (DXinBiaoZhun)this.dXinBiaoZhunService.getById(Integer.valueOf(Integer.parseInt(hangBiaoShi)));
      model.addAttribute("DXinBiaoZhun", cla);
      model.addAttribute("keyWordResult", ids);
      model.addAttribute("state", state);
      GDangAnMenLei dam = this.gDangAnMenLeiService.getByFenLeiHao(cla.getFenLeiHao());
      if (dam != null) {
        model.addAttribute("dangHaoGuiZe", dam.getDangHaoGuiZe());
        model.addAttribute("fenGeFu", dam.getFenGeFu());
      } 
      String server = getRequest().getParameter("server");
      String table = getRequest().getParameter("table");
      model.addAttribute("OFDType", AppConfiguration.getConfigValue("OFDType"));
    } 
    model.addAttribute("type", type);
    model.addAttribute("textKey", textKey);
    return "danganzhengli/D_XinBiaoZhun/D_XinBiaoZhun_edit";
  }
  
  @RequestMapping({"/delete.do"})
  @ResponseBody
  public void remove(HttpServletRequest request, HttpServletResponse response) {
    ResultMessage rm = new ResultMessage();
    String hangBiaoShi = request.getParameter("hangBiaoShi");
    String server = request.getParameter("server");
    if (StringUtils.isNotBlank(hangBiaoShi)) {
      String info = "";
      try {
        this.commonService.deleteByUser(getCurrentUser(), server, getTable(), hangBiaoShi);
        rm.setSuccess(true);
        info = "删除成功！";
      } catch (Exception e) {
        e.printStackTrace();
        rm.setSuccess(false);
        info = "删除失败！";
      } 
      rm.setInfo(info);
      rm.addResultMessage("data", "[{}]");
      responseWriter(response, rm.toString());
    } 
    rm.setSuccess(false);
    rm.setInfo("删除失败，选择的记录无效！");
    responseWriter(response, rm.toString());
  }
}
